package de.uni_passau.fim.seibt.gitwrapper.repo;

import de.uni_passau.fim.seibt.gitwrapper.process.ProcessExecutor;

import java.util.Optional;
import java.util.function.Function;

public class Branch extends Reference {

    public Branch(Repository repo, String name) {
        super(repo, name);
    }

    public Boolean pull() {
        Optional<ProcessExecutor.ExecRes> fetch = git.exec(repo.getDir(), "pull");
        Function<ProcessExecutor.ExecRes, Boolean> toBoolean = res -> {
            boolean failed = git.failed(res);

            if (failed) {
                LOG.warning(() -> String.format("Pull of %s failed.", this));
            }

            return !failed;
        };

        return fetch.map(toBoolean).orElse(false);
    }

    @Override
    public String getId() {
        return repo.toHash(id).orElse(id);
    }

    public String getName() {
        return id;
    }
}
